

WndRectangle  proc uses esi edi ebx, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

		LOCAL	ps:PAINTSTRUCT, hdc:HDC, pRectData:DWORD, hBrush:DWORD 
		LOCAL	xLeft:DWORD, xRight:DWORD, yTop:DWORD, yBottom:DWORD
		LOCAL	nRed:WORD, nGreen:WORD, nBlue:WORD
		
	.IF	uMsg ==WM_CREATE
		PuPo rectangle.Hwnd,hWnd		;le seul important sur les deux fournis	
		;-----Allocate memory for window private     MessageBox
		invoke  GetProcessHeap
		invoke  HeapAlloc, eax, HEAP_ZERO_MEMORY, sizeof RECTDATA
		;mmorise le pointeur pour la feuille
		invoke SetProp,hWnd,addr prop_pointeur,eax
		;--------Start the timer going
		invoke SetTimer, hWnd, 1, 250, 0					
		return  0

	.ELSEIF uMsg ==WM_SIZE			; If not minimised, save window size		
		.IF	wParam != SIZE_MINIMIZED
			invoke GetProp,hWnd,addr prop_pointeur		
			mov	pRectData, eax
			mov	ebx, eax
			LOWORD	lParam
			mov	RECTDATA.cxClient[ebx],ax
			HIWORD  lParam
			mov	RECTDATA.cyClient[ebx],ax
		.ENDIF
		return 0
	.ELSEIF uMsg ==WM_TIMER			; Display a random rectangle
		invoke GetProp,hWnd,addr prop_pointeur			
		mov	ebx,eax
		mov	bx,RECTDATA.cxClient[ebx]
		mov	al,16
		call random		; Get random number 16 bits big (in eax)
		mov	edx,0
		div	bx
		mov	xLeft,edx	; Get remainder (modulus)

		mov	al,16
		call	random
		mov	edx,0
		div	bx
		mov	xRight,edx

		mov	al,16
		call	random		
		mov	edx,0
		div	bx
		mov	yTop,edx

		mov	al,16
		call	random		
		mov	edx,0
		div	bx
		mov	yBottom,edx

		mov	al,16
		call	random
		and	ax, 255
		mov	nRed, ax

		mov	al,16
		call	random
		and	ax, 255
		mov	nGreen, ax

		mov	al,16
		call	random
		and	ax, 255
		mov	nBlue,ax

		invoke	GetDC, hWnd
		mov	hdc, eax

		mov	al,Byte ptr nBlue	; Use RGB values to make COLORREF 
		shl	eax,8
		add	al,Byte ptr nGreen
		shl	eax,8
		add	al,Byte ptr nRed
		add	eax,0FFFFFFh		; Mask out top byte to complete COLORREF dword 

		invoke	CreateSolidBrush, eax 	
		mov	hBrush, eax
		invoke	SelectObject, hdc, hBrush

		MIN	xLeft, xRight				; Get the corners
		push	eax
		MIN	yTop, yBottom
		push 	eax
		MAX	xLeft, xRight
		push	eax
		MAX	yTop, yBottom

		pop	ebx
		pop	ecx
		pop	edx
		invoke	Rectangle, hdc, edx, ecx, ebx, eax	; Draw rectangle
		invoke	ReleaseDC, hWnd, hdc
		invoke	DeleteObject, hBrush

		return  0
	
	.ELSEIF uMsg ==WM_PAINT

		invoke  InvalidateRect, hWnd, 0, TRUE
		invoke	BeginPaint, hWnd, ADDR ps
		mov	hdc, eax
		invoke	EndPaint, hWnd, ADDR ps
		return  0

	.ELSEIF uMsg ==WM_MDIACTIVATE		; Set appropriate menu
		mov	eax, lParam
		.IF	eax ==hWnd
			invoke	SendMessage, Frame.Hclientcreate, WM_MDISETMENU,rectangle.Hmenu, \
				rectangle.Hsubmenu
		.ELSE
			invoke	SendMessage, Frame.Hclientcreate, WM_MDISETMENU,Frame.Hmenu, \
				Frame.Hsubmenu	 	
		.ENDIF
		invoke	DrawMenuBar, Frame.Hwnd
		return 0 		    	
	.ELSEIF uMsg ==WM_DESTROY
		invoke GetProp,hWnd,addr prop_pointeur			
		mov	pRectData, eax
		invoke	GetProcessHeap
		invoke	HeapFree, eax, 0, pRectData
		invoke 	RemoveProp,hWnd,addr prop_pointeur
		invoke	KillTimer, hWnd, 1
		return 0
	.ENDIF 
	invoke  DefMDIChildProc, hWnd, uMsg, wParam, lParam
	return	eax
WndRectangle	endp


;faux random,srie arithmtique (sophistiqu mais srie quand mme)
random proc	uses ebx	   
;-----------------------------------------------;
; Generate Pseudo Random number (Fast)		;
;						;
; Entry:   al = size of random number		;					
;						;
; Return: eax = random number, cl bits in size	;
;-----------------------------------------------;
	mov	cl,al
	xor	eax,eax
	mov	bl,byte ptr random_init
	and	bl,1
Gen_bit:			; make n bit numbers
	shl	eax,1
	mov	edx,random_init	; Copy seed  
	shr	edx,9
	xor	bl,dl
	shr	edx,5
	xor	bl,dl
	bt	ebx,1		; Copy bit 1 to carry flag
	rcr	random_init,1	; Rotate seed right 1 bit
	setc	bl		; Set bl TRUE if carry is set		
	or	al,bl
	dec	cl
	jnz	Gen_bit
;--------------	
	ret
random  endp






